# GitScord webhook

A middleman webhook between Gitlab and Discord, in order to have fancy messages.

# GitScord webhook (Français)

GitScord est un webhook intermédiaire entre Gitlab et Discord, pour avoir des messages plus agréable à lire que ceux fournit nativement par Gitlab.

## Fonctionnalité
GitScord utilise un maximum de possibilités de mise en forme de Discord pour rendre les messages assez complets et lisibles à la fois.

Fonctionnalités existantes :
 * support des commits, tags, issues, notes, merge requests
 * multilingue
 * contrôle des aspects du bot dans Discord
 * 100% PHP, installation simple avec très peu de dépendances

Fonctionnalités en développement :
 * support des job, pipeline, wikipage
 * mode moins verbeux

## Installation
### Prérequis
GitScord est écrit entièrement en PHP. Comme le module *JSON* fait parti du PHPcore, le seul prérequis est d'avoir PHP >= 5.2.0 ou PHP >= 7, compilé avec le module *curl*.

Le serveur sur lequel est placé le script doit être accessible en HTTP(S) depuis votre Gitlab, et ce serveur doit pouvoir faire une requête HTTP(S) vers *discordapp.com*.

### Configuration
Dans un premier temps, créez un webhook dans les paramètres de votre serveur Discord (se référer à l'aide sur le site officiel de Discord si besoin).

L'étape suivante consiste à créé un fichier de configuration *gitscord_webhook_config.json*.
Vous pouvez vous aider des fichiers *gitscord_webhook_config.json.exemple.full* et *gitscord_webhook_config.json.exemple.minimal*, qui contiennent respectivement la liste exaustive des paramètres et la liste des paramètres obligatoirement requis.
Définition des paramètres :
 * discord_url : adresse du webhook fourni par Discord
 * language : langue des messages envoyés par le bot, choisir entre en, es et fr
 * bot_name : nom du bot sur Discord (remplace le nom défini dans Discord)
 * bot_avatar : image de profil du bot sur Discord  (remplace l'image défini dans Discord), mettre une URL absolue

Il suffit ensuite de mettre le fichier PHP (*gitscord_webhook.php*, mais vous pouvez le renommer à votre convenance) dans un des dossiers servis par votre serveur HTTP(S), avec le fichier *gitscord_webhook_config.json* (ne pas renommer, ou en changer le nom dans le script PHP).

Enfin dans Gitlab, menus "Settings" puis "Integrations" d'un projet, indiquer l'URL du fichier PHP et choisissez les événements à afficher dans Discord.

## Contributions
Pour aider à développer ce projet, vous pouvez notamment ouvrir des issues sur Gitlab pour :
 * les éventuels bugs que vous constatez à l'utilisation
 * les failles de sécurité que vous trouvez (avec le label *Security*)
 * des idées de nouvelles fonctionnalités (avec le label *Feature*)
